%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Az f függvény [a, b] intervallum feletti numerikus integráljának
% meghatározása n db egyenlő h = (b-a)/n hosszúságú részintervallum
% ekvidisztáns x_i alappontjaiban számolt h * sum(w_i * f(x_i))
% kvadratúrák összegzésével
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
format long;
% A paraméterek megadása
a = 0;
b = pi/2;
f = @(x) sin(x);
w = [1/6 4/6 1/6];
n = 1000;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h = (b-a)/n;
m = size(w, 2);
s = 0;
% A kvadratúrák összegzése
for i = 1:n
    a0 = a + h * (i-1);
    b0 = a + h * i;
    x = linspace(a0, b0, m);
    s = s + h * sum(w .* f(x));
end
% A numerikus integrál értékének kiírása
s
