%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Matlab script az f függvény [a, b] intervallum feletti integráljának
% kiszámítására.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Az intervallum és a függvény megadása
a = 0;
b = pi/2;
f = @(x) sin(x);
% A függvény intervallum feletti integráljának pontos értéke
int = 1;
% A h * sum(v_i*f_i) kvadratúra-formula együtthatóinak megadása
coeffs = [1/6 4/6 1/6];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Másodlagos paraméterek
m = length(coeffs) - 1; % részintervallum belső pontjainak száma + 1
H = []; % részintervallum-hosszúságok vektora
D = []; % hibák vektora
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Iteráció
for j = 1:11; % iterátor
    n = 2^j; % részintervallumok száma
    x = a:(b-a)/(m*n):b; % összes pont
    y = f(x); % összes függvényérték
    h = (b-a)/n; % részintervallumok hossza
    H = [H, h]; 
    num_int = 0; % numerikus integrál
% Numerikus integrál kiszámítása
    for i = 1:(m+1)
        num_int = num_int + h*(sum(y(i:m:i+(n-1)*m)))*coeffs(i);
    end
    delta = int - num_int; % a numerikus integrálás hibája
    D = [D, delta];
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Eredmények kiírása
format longg;
H
D
% A nem nulla hibájú pontok ábrázolása
plot(log(H(abs(D) > 0)), log(D(abs(D) > 0)))
