%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Az
% a * u_xx + b * u_x + c * u = f(x)
% u(0) = p0
% u(L) = pL
% peremérték-feladat numerikus megoldása a véges differenciák
% módszerével h = l/n rácsállandójú ekvidisztáns rácson
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
format long;
% A paraméterek megadása:
a = 1;
b = 1;
c = 0;
f = @(x) 2+2*x;
L = 1;
p0 = 0;
pL = 1;
n = 100;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h = L/n;
X = linspace(0, L, n+1);
X0 = X(2:end-1);
% Centrális második derivált
D = zeros(n+1, n+1);
for i = 2:n
    D(i, i-1) = 1/h^2;
    D(i, i+1) = 1/h^2;
    D(i, i) = -2/h^2;
end
% Előrenéző első derivált
A0 = zeros(n+1, n+1);
for i = 2:n
    A0(i, i+1) = 1/h;
    A0(i, i) = -1/h;
end
% Hátranéző első derivált
A1 = zeros(n+1, n+1);
for i = 2:n
    A1(i, i) = 1/h;
    A1(i, i-1) = -1/h;
end
% Centrális első derivált
A2 = zeros(n+1, n+1);
for i = 2:n
    A2(i, i+1) = 1/(2*h);
    A2(i, i-1) = -1/(2*h);
end
% Séma megadása
A = A0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Az egyenletrendszer mátrixa
M = a * D + b * A + c * eye(n+1);
M(1, 1) = 1;
M(end, end) = 1;
% Az egyenletrendszer jobb oldala
g0 = f(X0);
g = [p0, g0, pL]';
% Az egyenletrendszer megoldása
u = (M\g)';
% A megoldás ábrázolása
plot(X, u, '-o');
