%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Matlab szkript az
%
% a*u_xx + b*u_x + c*u = f(x)
% u(0) = p0
% u(L) = pL
% 
% peremérték-feladat megoldására
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% A peremérték-feladat paraméterei:
a = 1;
b = 1;
c = 0;
f = @(x) 2 + 2*x;
L = 1;
p0 = 0;
pL = 1;
% A rács belső pontjainak száma
n = 30;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Másodlagos paraméterek
h = L/n; % rácsállandó
X = 0:h:L; % rácspontok vektora
X0 = X(2:end-1); % belső rácspontok vektora
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Alkalmazott numerikus sémák
% Második derivált
% Centrális második derivált
D = 1/h^2*(diag((-2)*[0, ones(size(X0)), 0],0)+diag([ones(size(X0)), 0],-1)+diag([0, ones(size(X0))],1));
% Első derivált
% Előremutató derivált
A = 1/h*(diag((-1)*[0, ones(size(X0)), 0], 0)+diag([0, ones(size(X0))], 1));
% Hátranéző derivált
% A = 1/h*(diag(1*[0, ones(size(X0)), 0], 0)+(-1)*diag([ones(size(X0)), 0], -1));
% Centrális derivált
% A = 1/h*(diag(1/2*[0, ones(size(X0))], 1)+(-1)/2*diag([ones(size(X0)), 0], -1));
% Csonkolt egységmátrix
I = diag([0, ones(size(X0)), 0]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Az M*u = g egyenletrendszer előállítása és megoldása
% A mátrix előállítása
M = a*D + b*A + c*I;
M(1,1) = 1;
M(end,end) = 1;
% A jobboldal előállítása
g = f(X0);
g = [p0, g, pL];
% Az egyenletrendszer megoldása
u = (M\g')';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% A megoldás ábrázolása
plot(X, u, '-o');
